this.name = "feudal-challenge.js";
this.author = "Ramirez";
this.copyright = "October 2012";
this.description = "World script for setting up feudal challenges";
this.version = "9.0";

// Event handlers

this.startUp = function()
{if(!missionVariables.feudal_planetinfo)
	 {missionVariables.feudal_planetinfo = "SET"
	 this.setPlanetOverrides()}
	 
if(missionVariables.feudal_planetinfo.indexOf(galaxyNumber) == -1)
	{this.setPlanetOverrides()}
}

this.shipDockedWithStation = function()
{this.missionScreens()}

this.guiScreenChanged = function()
{if(guiScreen == "GUI_SCREEN_MARKET")
this.missionScreens()}


//defining possible ships

this.defineChallengerShips = function()

	{ 	if(missionVariables.feudal_challenger_ship == "Ritter-Class Jaeger")
		missionVariables.feudal_challenger_role = [missionVariables.feudal_challenger_house]+"-knight"
	
		if(missionVariables.feudal_challenger_ship == "Freiherr-Class Korvette")
		missionVariables.feudal_challenger_role = [missionVariables.feudal_challenger_house]+"-lord"

		if(missionVariables.feudal_challenger_ship == "Prinz-Class Zerstoerer")
		missionVariables.feudal_challenger_role = [missionVariables.feudal_challenger_house]+"-prince"
	}
	
this.defineChallengerGender = function() // pick a gender and house

{	
	 for (var i=0; i<5; i++) missionVariables.feudal_challenger_house = expandDescription("[feudal_house_"+[galaxyNumber]+"]")
	missionVariables.feudal_challenger_gender = expandDescription("[feudal_gender]")
		
		if(missionVariables.feudal_challenger_gender == "he")
		{	
			missionVariables.feudal_challenger_level1_title = "Sir"
			missionVariables.feudal_challenger_level2_title = "Lord"
		}									       
		
		if(missionVariables.feudal_challenger_gender == "she")
		{	
			missionVariables.feudal_challenger_level1_title = "Lady"
			missionVariables.feudal_challenger_level2_title = "Lady"	
		}	
}
			
this.defineChallengerDetails = function()		
	{
		this.challengerProb = (Math.random())
		{		
			if(this.challengerProb < 0.65)
			
					{	
					
					missionVariables.feudal_challenger_title = missionVariables.feudal_challenger_level1_title
					missionVariables.feudal_challenger_rank = "knight"
					missionVariables.feudal_challenger_ship = "Ritter-Class Jaeger"
					missionVariables.feudal_challenger_text = "feudal_challenger_text_level1"
					missionVariables.feudal_challenger_rank_no = 1
					missionVariables.feudal_challenger_score = 600 + (Math.floor(Math.random()*300))
					this.feudalChallengerRating = missionVariables.feudal_challenger_score*375*300*2*25/15
					}
					
			if(this.challengerProb >= 0.65 && this.challengerProb < 0.90)
				
					{
					missionVariables.feudal_challenger_title = missionVariables.feudal_challenger_level2_title
					missionVariables.feudal_challenger_rank = player.rankGenerator_feudal_middle_rank
					missionVariables.feudal_challenger_ship = "Freiherr-Class Korvette"
					missionVariables.feudal_challenger_text = "feudal_challenger_text_level2"
					missionVariables.feudal_challenger_rank_no = 2
					missionVariables.feudal_challenger_score = 900 + (Math.floor(Math.random()*1000))
					this.feudalChallengerRating = missionVariables.feudal_challenger_score*360*750*4*32/25
					}
					
			if(this.challengerProb >= 0.90)
				
					{
					missionVariables.feudal_challenger_title = missionVariables.feudal_challenger_level2_title
					missionVariables.feudal_challenger_rank = player.rankGenerator_feudal_high_rank
					missionVariables.feudal_challenger_ship = "Prinz-Class Zerstoerer"
					missionVariables.feudal_challenger_text = "feudal_challenger_text_level3"
					missionVariables.feudal_challenger_rank_no = 3
					missionVariables.feudal_challenger_score = 1500 + (Math.floor(Math.random()*2000))
					this.feudalChallengerRating = missionVariables.feudal_challenger_score*400*1100*4*50/35
					}			
		}
}							       
		
this.defineChallengerOdds = function()

	{
		missionVariables.feudal_challenger_odds = Math.round(this.feudalChallengerRating*100/(50*player.ship.maxSpeed*player.ship.maxEnergy*player.ship.thrust*player.ship.missileCapacity))/100 
		
		if(missionVariables.feudal_challenger_odds > 10)
		missionVariables.feudal_challenger_odds = 10
		
		missionVariables.feudal_challenger_return = Math.round(missionVariables.feudal_challenger_odds*100)
	}
	
this.defineGeneratorInputs = function()

{
	player.rankGenerator_house = missionVariables.feudal_challenger_house
	player.rankGenerator_gender = missionVariables.feudal_challenger_gender
	
}

this.defineGeneratorOutputs = function()

{	
	missionVariables.feudal_challenger_of = player.rankGenerator_of
	missionVariables.feudal_challenger_firstname = player.rankGenerator_feudal_firstname
	missionVariables.feudal_challenger_lastname = player.rankGenerator_feudal_lastname
	
}

this.feudalChallengeOffer = function()

{	
		this.defineChallengerGender()
		this.defineGeneratorInputs()
		player.feudalRankGenerator()
		this.defineChallengerDetails()
		this.defineGeneratorOutputs()
		this.defineChallengerShips()
		this.defineChallengerOdds()
		missionVariables.feudal_challenger_offer = "CHALLENGE_OFFERED"
		missionVariables.feudal_player_credits = Math.round(player.credits*100)/100 
}

this.resetChallenger = function()
{	missionVariables.feudal_challenger_title = null
	missionVariables.feudal_challenger_gender = null
	missionVariables.feudal_challenger_firstname= null
	missionVariables.feudal_challenger_lastname = null
	missionVariables.feudal_challenger_rank = null
	missionVariables.feudal_challenger_ship = null
	missionVariables.feudal_challenger_text = null
	missionVariables.feudal_challenger_rank_no = null
	missionVariables.feudal_challenger_score = null
	missionVariables.feudal_challenger_odds = null
	missionVariables.feudal_challenger_return = null
	missionVariables.feudal_challenger_stake = null
	missionVariables.feudal_challenger_page = null
	missionVariables.feudal_challenger_house = null
	missionVariables.feudal_challenger_of = null
	missionVariables.feudal_challenger_level1_title = null
	missionVariables.feudal_challenger_level2_title = null
	missionVariables.feudal_challenger_role = null
	player.rankGenerator_house = null
	player.rankGenerator_gender = null
	missionVariables.feudal_challenger_eligible = null
}


this.checkPlayerShip = function()
{
	this.playerSubentities = player.ship.subEntities
	this.playerSubentitiesString = playerSubentities.toString();
	if(playerSubentitiesString.indexOf("turret") != -1)
	missionVariables.feudal_challenger_eligible = "FALSE"
}

// Mission screens

this.missionScreens = function()

    {   if(guiScreen == "GUI_SCREEN_MISSION" || !player.ship.docked) return;
    
	if(player.ship.dockedStation.hasRole("feudal-hunting-lodge") && (missionVariables.feudal_tournament_home != system.name))
	
	
	{	if(guiScreen == "GUI_SCREEN_MARKET")		 
	
		{
			
		this.checkPlayerShip()	
		
			
		if(!missionVariables.feudal_challenger || missionVariables.feudal_challenger == "NONE_SET")
		{
		  
		  if(missionVariables.feudal_challenger_count > 5)
		  {mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_challenger_nomore"})} 
		  
		  else
		  
		  {this.resetChallenger()
					missionVariables.feudal_challenger_page = "1"
					this.feudalChallengeOffer()
					mission.runScreen({title: "Royal Hunting Lodge", messageKey: [missionVariables.feudal_challenger_text], model: [missionVariables.feudal_challenger_role],
                                choicesKey: "feudal_challenger_board_choices"}, this.choiceEvaluation);}}
					
		
		
		if(missionVariables.feudal_challenger_offer == "CHALLENGE_DEFERRED")
			{
			
			mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_challenger_accepted_text", choicesKey: "feudal_challenger_launch_choices"}, this.choiceEvaluation);
			missionVariables.feudal_challenger_offer = "CHALLENGE_LAUNCH"}
		
		}
		
		if(missionVariables.feudal_challenger == "RUNNING")	   
			{
			mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_challenger_forfeit"})	
			missionVariables.feudal_challenger = "NONE_SET"
			this.resetChallenger()
			this.restoreSystems()}
			
		if(missionVariables.feudal_challenger == "FORFEIT")	   
			{
			mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_challenger_forfeit-alt"})
			missionVariables.feudal_challenger = "NONE_SET"
			this.resetChallenger()
			this.restoreSystems()}


		if(missionVariables.feudal_challenger == "VICTORY")
			{
			mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_challenger_victory", music: "feudal-music.ogg"})
			player.credits += missionVariables.feudal_challenger_stake
			player.credits += missionVariables.feudal_challenger_return
			missionVariables.feudal_challenger = "NONE_SET"
			this.resetChallenger()
			this.restoreSystems()}
		
	}
		
	if(player.ship.dockedStation.isMainStation)
		{if(missionVariables.feudal_challenger == "RUNNING" || missionVariables.feudal_challenger == "FORFEIT")
		{missionVariables.feudal_challenger = "NONE_SET"
		this.resetChallenger()
		this.restoreSystems()
		player.commsMessage("Feudal Hunting Lodge: You have forfeited the challenge.")}}
}	
    
this.choiceEvaluation = function(choice)

	{
		if(missionVariables.feudal_challenger_offer == "CHALLENGE_OFFERED")
			
				{	
					if(missionVariables.feudal_challenger_page == "1")
								
						{	if(choice == "accept_challenger")	
					
							{	
								if(missionVariables.feudal_challenger_odds > 0.2)
								{mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_challenger_bet_text", choicesKey: "feudal_challenger_bet_choices", model: [missionVariables.feudal_challenger_role]}, this.choiceEvaluation);
								missionVariables.feudal_challenger_offer = "CHALLENGE_BET"}
								
								if(missionVariables.feudal_challenger_odds <= 0.5)
								mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_challenger_low_odds"});
								
								if(missionVariables.feudal_challenger_eligible == "FALSE")
								mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_challenger_ineligible"});
							}
					
							if(choice == "decline_challenger")	
			
							{	
								missionVariables.feudal_challenger_page = "2"
								missionVariables.feudal_challenger_offer = null	
								choice = null
								this.feudalChallengeOffer()
								mission.runScreen({title: "Royal Hunting Lodge", messageKey: [missionVariables.feudal_challenger_text], choicesKey: "feudal_challenger_board_choices", model: [missionVariables.feudal_challenger_role]}, this.choiceEvaluation);
							}	
					
							if(choice == "exit_challenger")		
								{missionVariables.feudal_challenger = "NONE_SET"
								missionVariables.feudal_challenger_offer = null
								this.resetChallenger()
								return}
						}
							
					if(missionVariables.feudal_challenger_page == "2")
								
						{	if(choice == "accept_challenger")
					
							{	
								if(missionVariables.feudal_challenger_odds > 0.2)
								{mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_challenger_bet_text", choicesKey: "feudal_challenger_bet_choices", model: [missionVariables.feudal_challenger_role]}, this.choiceEvaluation);
								missionVariables.feudal_challenger_offer = "CHALLENGE_BET"}
								
								if(missionVariables.feudal_challenger_odds <= 0.2)
								mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_challenger_low_odds"});
								
								if(missionVariables.feudal_challenger_eligible == "FALSE")
								mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_challenger_ineligible"});
							}
					
							if(choice == "decline_challenger")	
			
							{	
								missionVariables.feudal_challenger_page = "3"
								missionVariables.feudal_challenger_offer = null
								choice = null
								this.feudalChallengeOffer()
								mission.runScreen({title: "Royal Hunting Lodge", messageKey: [missionVariables.feudal_challenger_text], choicesKey: "feudal_challenger_board_choices_alt", model: [missionVariables.feudal_challenger_role]}, this.choiceEvaluation);
								missionVariables.feudal_challenger_page = "3"
							}	
					
							if(choice == "exit_challenger")		
								{missionVariables.feudal_challenger = "NONE_SET"
								missionVariables.feudal_challenger_offer = null
								this.resetChallenger()
								return}
						}	
						
					if(missionVariables.feudal_challenger_page == "3")
								
						{	if(choice == "accept_challenger")
					
							{	
								if(missionVariables.feudal_challenger_odds > 0.2)
								{mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_challenger_bet_text", choicesKey: "feudal_challenger_bet_choices", model: [missionVariables.feudal_challenger_role]}, this.choiceEvaluation);
								missionVariables.feudal_challenger_offer = "CHALLENGE_BET"}
								
								if(missionVariables.feudal_challenger_odds <= 0.2)
								mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_challenger_low_odds"});
								
								if(missionVariables.feudal_challenger_eligible == "FALSE")
								mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_challenger_ineligible"});
							}
					
							if(choice == "decline_challenger")	
			
							{
								missionVariables.feudal_challenger_page = "1"			
								missionVariables.feudal_challenger = "NONE_SET"
								missionVariables.feudal_challenger_offer = null
								choice = null
								this.resetChallenger()
							}	
					
							if(choice == "exit_challenger")		
								{missionVariables.feudal_challenger = "NONE_SET"
								missionVariables.feudal_challenger_offer = null
								this.resetChallenger()
								
								return}
						}			
				}
			
		if(missionVariables.feudal_challenger_offer == "CHALLENGE_BET")
			
				{	if(choice == "bet100")
				
					{	if(player.credits >= 100)
					
						{	missionVariables.feudal_challenger_offer = "CHALLENGE_LAUNCH"
							missionVariables.feudal_challenger_stake = 100
							missionVariables.feudal_challenger_return = Math.round([missionVariables.feudal_challenger_stake]*[missionVariables.feudal_challenger_odds])
							mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_challenger_accepted_text", choicesKey: "feudal_challenger_launch_choices"}, this.choiceEvaluation);
							player.credits -= 100
							missionVariables.feudal_challenger = "ACCEPTED"

						}
						
						else
							
						mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_challenger_refused", choicesKey: "feudal_challenger_bet_choices"}, this.choiceEvaluation);
					}	
						
					if(choice == "bet1000")
					
					{	if(player.credits >= 1000)
					
						{	missionVariables.feudal_challenger_offer = "CHALLENGE_LAUNCH"
							missionVariables.feudal_challenger_stake = 1000
							missionVariables.feudal_challenger_return = Math.round([missionVariables.feudal_challenger_stake]*[missionVariables.feudal_challenger_odds])
							mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_challenger_accepted_text", choicesKey: "feudal_challenger_launch_choices"}, this.choiceEvaluation);
							player.credits -= 1000
							missionVariables.feudal_challenger = "ACCEPTED"
						}
						
						else
						
	
							mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_challenger_refused", choicesKey: "feudal_challenger_bet_choices"}, this.choiceEvaluation);
						
					}	
					
					if(choice == "bet10000")
					
					{	if(player.credits >= 10000)
						
						{	missionVariables.feudal_challenger_offer = "CHALLENGE_LAUNCH"
							missionVariables.feudal_challenger_stake = 10000
							missionVariables.feudal_challenger_return = Math.round([missionVariables.feudal_challenger_stake]*[missionVariables.feudal_challenger_odds])
							mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_challenger_accepted_text", choicesKey: "feudal_challenger_launch_choices"}, this.choiceEvaluation);
							player.credits -= 10000
							missionVariables.feudal_challenger = "ACCEPTED"
						}
						
						else
						mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_challenger_refused", choicesKey: "feudal_challenger_bet_choices"}, this.choiceEvaluation);
						
					}
					
					if(choice == "betcancel")
						{missionVariables.feudal_challenger_offer = "CHALLENGE_OFFERED"
						mission.runScreen({title: "Royal Hunting Lodge", messageKey: [missionVariables.feudal_challenger_text], choicesKey: "feudal_challenger_board_choices", model: [missionVariables.feudal_challenger_role]}, this.choiceEvaluation);
						}	
				}		
				
		if(missionVariables.feudal_challenger_offer == "CHALLENGE_LAUNCH")
				
				{	if(choice == "begin_challenge")
				
						{	missionVariables.feudal_challenger = "RUNNING"
							missionVariables.feudal_challenger_offer = null
							player.ship.launch()
							++missionVariables.feudal_challenger_count
							
						}
						
						
					if(choice == "defer_challenge")
				
						{
							mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_challenger_deferred"});
							missionVariables.feudal_challenger_offer = "CHALLENGE_DEFERRED"	
						}	
				}
	}			

	
// ship appearance on launching
	
this.shipWillLaunchFromStation = function()

{	this.setUpSystem()

	if(missionVariables.feudal_challenger == "RUNNING")
	{	system.legacy_addShipsAtPrecisely([missionVariables.feudal_challenger_role], 1, "wsm", [0, 120100, 0])
		this.disableSystems()}
		else
	if(missionVariables.feudal_challenger_offer != "CHALLENGE_DEFERRED")
	missionVariables.feudal_challenger = "NONE_SET"
}
this.shipWillExitWitchspace = function()
{	this.setUpSystem()
	missionVariables.feudal_challenger_count = 0 
	if(missionVariables.feudal_challenger == "RUNNING" || missionVariables.feudal_challenger == "FORFEIT" || missionVariables.feudal_challenger_offer == "DEFERRED")
		{missionVariables.feudal_challenger = "NONE_SET"
		missionVariables.feudal_challenger_offer = null
		missionVariables.feudal_challenger_stake = null
		player.commsMessage("Feudal challenge has been forfeit.")
		this.restoreSystems()}	

	
	if(missionVariables.feudal_challenger == "VICTORY")
		{missionVariables.feudal_challenger = "NONE_SET"
		missionVariables.feudal_challenger_offer = null
		missionVariables.feudal_challenger_stake = null
		this.restoreSystems()}	
}






this.setPlanetOverrides = function()
{	missionVariables.feudal_planetinfo = missionVariables.feudal_planetinfo+galaxyNumber
	for (var i=0; i<256; i++)
	{if(System.infoForSystem(galaxyNumber,[i]).government == 1)
	
			{if(galaxyNumber = 0 && System.infoForSystem(galaxyNumber,[i]).techlevel >= 7 || galaxyNumber == 1 && System.infoForSystem(galaxyNumber,[i]).techlevel >= 5 ||
				galaxyNumber == 2 && System.infoForSystem(galaxyNumber,[i]).techlevel >= 7 || galaxyNumber == 4 && System.infoForSystem(galaxyNumber,[i]).techlevel >= 7 ||
				galaxyNumber == 5 && System.infoForSystem(galaxyNumber,[i]).techlevel >= 8)
				{System.infoForSystem(galaxyNumber,[i]).description = System.infoForSystem(galaxyNumber,[i]).description + " Note that this system is a member of the Feudal States."}
			}
	}	
}


this.playerEnteredNewGalaxy = function()
{	if(missionVariables.feudal_planetinfo.indexOf(galaxyNumber) == -1)
	this.setPlanetOverrides()}

this.setUpSystem = function()
{
	if(system.government == 1)
	
	{
	
		if(galaxyNumber == 0 && system.techLevel >=7 || galaxyNumber == 1 && system.techLevel >= 5 || galaxyNumber == 2 && system.techLevel >= 7 || galaxyNumber == 4 && system.techLevel >=7 || galaxyNumber == 5 && system.techLevel >=8)

		{
		var currentLocationNo = system.ID
		var currentLocationName = System.systemNameForID ([currentLocationNo])
		
		if(system.countShipsWithRole("feudal-hunting-lodge") == 0)
		system.legacy_addShipsAtPrecisely("feudal-hunting-lodge", 1, "wsm", [0, 100000, 0])
		
		if(system.countShipsWithRole("feudal-buoy") == 0)
		system.legacy_addShipsAtPrecisely("feudal-buoy", 1, "wsm", [0, 122000, 0])
		
		
		if(missionVariables.feudal_tournament_home != system.name && system.countShipsWithRole("feudal-knight") == 0)  
		{system.legacy_addShipsWithinRadius([currentLocationName]+"-knight", 4, "wsm", [0, 100000, 0], 10000)
		system.legacy_addSystemShips([currentLocationName]+"-lord", 2, 0.8)
		system.legacy_addSystemShips("feudal-knight", 3, 0.6)}
		}
	}
}



this.disableSystems = function()
{
	if(player.ship.equipmentStatus("EQ_CLOAKING_DEVICE") == "EQUIPMENT_OK")
		{	player.ship.removeEquipment("EQ_CLOAKING_DEVICE")
			player.ship.awardEquipment("EQ_FS_CLOAK_PLACEHOLDER")
			player.consoleMessage("Cloaking Device disabled")
		}
		
	if(player.ship.equipmentStatus("EQ_ENERGY_BOMB") == "EQUIPMENT_OK")
		{	player.ship.removeEquipment("EQ_ENERGY_BOMB")
			player.ship.awardEquipment("EQ_FS_BOMB_PLACEHOLDER")
			player.consoleMessage("Energy Bomb disabled")
		}
		
	this.storeMissileArray = player.ship.missiles;
	player.ship.awardEquipment("EQ_MISSILE_REMOVAL")
	player.ship.awardEquipment("EQ_FEUDAL_FLARE_MINE")
}

this.restoreSystems = function()

{	if(player.ship.equipmentStatus("EQ_FS_CLOAK_PLACEHOLDER") == "EQUIPMENT_OK")
		{	player.ship.removeEquipment("EQ_FS_CLOAK_PLACEHOLDER")
			player.ship.awardEquipment("EQ_CLOAKING_DEVICE")
			player.consoleMessage("Cloaking Device re-enabled")
		}
		
	if(player.ship.equipmentStatus("EQ_FS_BOMB_PLACEHOLDER") == "EQUIPMENT_OK")
		{	player.ship.removeEquipment("EQ_FS_BOMB_PLACEHOLDER")
			player.ship.awardEquipment("EQ_ENERGY_BOMB")
			player.consoleMessage("Energy Bomb re-enabled")
		}
	
	player.ship.awardEquipment("EQ_MISSILE_REMOVAL")
	for(restoreCounter = 0;restoreCounter<this.storeMissileArray.length;restoreCounter++)
        {player.ship.awardEquipment(this.storeMissileArray[restoreCounter].equipmentKey);}
}