this.name = "feudal-tournament.js";
this.author = "Ramirez";
this.copyright = "October 2012";
this.description = "World script for setting up feudal tournaments";
this.version = "10.0";

// Event handlers

this.shipDockedWithStation = function()

{	
	this.missionScreens()
}

this.missionScreenEnded = function()
{
	if(!player.ship.docked) return;
			
}

this.guiScreenChanged = function()

{	if(guiScreen == "GUI_SCREEN_MARKET")
	this.missionScreens()
}

this.defineTournamentHome = function()
{missionVariables.feudal_tournament_home = expandDescription("[feudal_house_"+[galaxyNumber]+"]")}

this.checkPlayerShip = function()
{
	this.playerSubentities = player.ship.subEntities
	this.playerSubentitiesString = playerSubentities.toString();
	if(playerSubentitiesString.indexOf("turret") != -1)
	missionVariables.feudal_tournament_eligible = "FALSE"
}


// Mission screens

this.missionScreens = function()

    {   if(guiScreen == "GUI_SCREEN_MISSION" || !player.ship.docked) return;
	
	if(!missionVariables.feudal_tournament_offer && !missionVariables.feudal_tournament)
	{
		if(galaxyNumber <= 2 || galaxyNumber == 4 || galaxyNumber == 5)
			{if(missionVariables.feudal_tournament_jumpcount > 50)
		
		
			{	this.defineTournamentHome()
				mission.runScreen({title: "Incoming Message", messageKey: "feudal_tournament_announcement", background: "redeagle.png"})
				missionVariables.feudal_tournament_offer = "TOURNAMENT_OPEN"
				mission.setInstructionsKey("feudal_tournament_location")
				missionVariables.feudal_tournament_deadline = clock.days + 30}
			}
	}
	
	if(missionVariables.feudal_tournament_offer == "TOURNAMENT_OPEN")
	{
		if(missionVariables.feudal_tournament_deadline)
		
		{	if(clock.days > missionVariables.feudal_tournament_deadline)
		
			{	this.defineTournamentGender()
				this.defineTournamentOpponentHouse()
				missionVariables.feudal_tournament_opponent_rank_no = Math.floor(Math.random()*2 + 1)
				this.defineTournamentInputs()
				player.feudalRankGenerator()
				this.defineTournamentOutputs()
				mission.runScreen({title: "Incoming Message", messageKey: "feudal_tournament_winner", background: "redeagle.png"})
				this.resetTournament()
				mission.setInstructionsKey(null)
				missionVariables.feudal_tournament_deadline = null
			}
	}
	}
	
	if(player.ship.dockedStation.hasRole("feudal-hunting-lodge") && missionVariables.feudal_tournament_home == system.name)
		{	
		if(guiScreen == "GUI_SCREEN_MARKET")		 
		{
			if(missionVariables.feudal_tournament_offer == "TOURNAMENT_OPEN")	
				{
				this.checkPlayerShip()
				
				if(missionVariables.feudal_tournament_eligible == "FALSE")
				{mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_tournament_ineligible"});}
				
				if(!missionVariables.feudal_tournament_eligible)
				{mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_tournament_offer", background: "redeagle.png", music: "feudal_music.ogg", choicesKey: "feudal_tournament_choices"}, this.choiceEvaluation)	
				missionVariables.feudal_tournament_offer = "TOURNAMENT_OFFERED"}
				
				}
			
			if(missionVariables.feudal_tournament_offer == "EVENT_BRIEFING")
				{
				mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_tournament_"+[missionVariables.feudal_tournament], choicesKey: "feudal_tournament_event_choices"}, this.choiceEvaluation)
				mission.setInstructionsKey("feudal_tournament_"+[missionVariables.feudal_tournament]+"_briefing")}		
		
			if(missionVariables.feudal_tournament_offer == "EVENT_DECLINED")
				{		
				mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_tournament_"+[missionVariables.feudal_tournament], choicesKey: "feudal_tournament_event_choices"}, this.choiceEvaluation)
				missionVariables.feudal_tournament_offer = "EVENT_BRIEFING"
				mission.setInstructionsKey("feudal_tournament_"+[missionVariables.feudal_tournament]+"_briefing")}
		}
		if(missionVariables.feudal_tournament == "EVENT1_RUNNING")
		{	
			
			if(missionVariables.feudal_tournament_kills >= 8)
				
			{
				mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_tournament_EVENT1_PASSED"})
				missionVariables.feudal_tournament = "EVENT2"
				missionVariables.feudal_tournament_offer = "EVENT_BRIEFING"
				missionVariables.feudal_tournament_kills = null
				this.restoreMissiles()
			}
			
			else
			{	mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_tournament_EVENT1_FAILED"})
				this.resetTournament()
				this.restoreMissiles()}
		}
			
		if(missionVariables.feudal_tournament == "EVENT2_RUNNING")
		{	
			if(player.ship.equipmentStatus("EQ_FS_BOMB_PLACEHOLDER") == "EQUIPMENT_OK")
					{	player.ship.removeEquipment("EQ_FS_BOMB_PLACEHOLDER")
						player.ship.awardEquipment("EQ_ENERGY_BOMB")
						player.consoleMessage("Energy Bomb re-enabled")}

			if(missionVariables.feudal_tournament_kills >= 4)
				
			{	mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_tournament_EVENT2_PASSED"})
				missionVariables.feudal_tournament = "EVENT3"
				missionVariables.feudal_tournament_offer = "EVENT_BRIEFING"
				missionVariables.feudal_tournament_kills = null
				this.restoreMissiles()
			}
			
			else
			{	mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_tournament_EVENT2_FAILED"})
				this.resetTournament()
				this.restoreMissiles()
			}
		}
		
		
		if(missionVariables.feudal_tournament == "EVENT3_RUNNING")
		{
			if(player.ship.equipmentStatus("EQ_FS_INJECTION_PLACEHOLDER", "EQUIPMENT_OK"))
			{	player.ship.removeEquipment("EQ_FS_INJECTION_PLACEHOLDER")
				player.ship.awardEquipment("EQ_FUEL_INJECTION")
				player.consoleMessage("Fuel Injectors re-enabled")}
				
		
			if(missionVariables.feudal_tournament_scoops >=1)
			
			{	mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_tournament_EVENT3_PASSED"})
				missionVariables.feudal_tournament_offer = "EVENT_BRIEFING"
				missionVariables.feudal_tournament = "EVENT4"
				missionVariables.feudal_tournament_scoops = null}
			
			else
			{	mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_tournament_EVENT3_FAILED"})
				this.resetTournament()}
		}
		
		if(missionVariables.feudal_tournament == "EVENT4_RUNNING")
		{
			if(missionVariables.feudal_tournament_scoops >=8)
			
			{	mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_tournament_EVENT4_PASSED"})
				missionVariables.feudal_tournament_offer = "EVENT_BRIEFING"
				missionVariables.feudal_tournament = "EVENT5"
				missionVariables.feudal_tournament_scoops = null
				this.restoreMissiles()}
			
			else
			{	mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_tournament_EVENT4_FAILED"})
				this.resetTournament()
				this.restoreMissiles()}
		}
		
		if(missionVariables.feudal_tournament == "EVENT5_RUNNING")
		{
			if(player.ship.equipmentStatus("EQ_FS_BOMB_PLACEHOLDER") == "EQUIPMENT_OK")
					{	player.ship.removeEquipment("EQ_FS_BOMB_PLACEHOLDER")
						player.ship.awardEquipment("EQ_ENERGY_BOMB")
						player.consoleMessage("Energy Bomb re-enabled")}
						
						
			if(missionVariables.feudal_tournament_ships <= 2)
			
			{	this.defineTournamentGender()
				this.defineTournamentInputs()
				player.feudalRankGenerator()
				this.defineTournamentOutputs()
				mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_tournament_EVENT5_PASSED"})
				missionVariables.feudal_tournament_offer = "EVENT_BRIEFING"
				missionVariables.feudal_tournament = "EVENT6"
				missionVariables.feudal_tournament_ships = null}
			
			else
			{	mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_tournament_EVENT5_FAILED"})
				this.resetTournament()}	
		}
		
		if(missionVariables.feudal_tournament == "EVENT6_RUNNING")
		{
			if(player.ship.equipmentStatus("EQ_FS_BOMB_PLACEHOLDER") == "EQUIPMENT_OK")
					{	player.ship.removeEquipment("EQ_FS_BOMB_PLACEHOLDER")
						player.ship.awardEquipment("EQ_ENERGY_BOMB")
						player.consoleMessage("Energy Bomb re-enabled")}
			
			if(missionVariables.feudal_tournament_kills == 1)
			
			{	
				mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_tournament_EVENT6_PASSED"})
				missionVariables.feudal_tournament_offer = null
				missionVariables.feudal_tournament = null
				missionVariables.feudal_tournament_kills = null
				missionVariables.feudal_score += 100
				player.credits += 100000
				this.resetTournament()
				this.restoreMissiles()}
			
			else
			{	mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_tournament_EVENT6_FAILED"})
				this.resetTournament()
				this.restoreMissiles()}	
		}
	}	
    }
    
    
this.removeMissiles = function()
{this.storeMissileArray = player.ship.missiles;
player.ship.awardEquipment("EQ_MISSILE_REMOVAL")}


this.restoreMissiles = function()
{player.ship.awardEquipment("EQ_MISSILE_REMOVAL")
	for(restoreCounter = 0;restoreCounter<this.storeMissileArray.length;restoreCounter++)
        {player.ship.awardEquipment(this.storeMissileArray[restoreCounter].equipmentKey);}
}

this.choiceEvaluation = function(choice)
	{
		if(missionVariables.feudal_tournament_offer == "TOURNAMENT_OFFERED")
			
				
			{	if(choice == "enter_tournament")	
					
							{	
								missionVariables.feudal_tournament = "EVENT1"
								missionVariables.feudal_tournament_offer = "EVENT_BRIEFING"
								mission.runScreen({title: "Royal Hunting Lodge", background: "redeagle.png", messageKey: "feudal_tournament_"+[missionVariables.feudal_tournament], choicesKey: "feudal_tournament_event_choices"}, this.choiceEvaluation)
								mission.setInstructionsKey("feudal_tournament_"+[missionVariables.feudal_tournament]+"_briefing")
								missionVariables.feudal_tournament_deadline = null
							}
					
				if(choice == "decline_tournament")	
			
							{
								mission.runScreen({title: "Royal Hunting Lodge", background: "redeagle.png", messageKey: "feudal_tournament_declined"})
								this.resetTournament()
								return
							}
			}
					
		if(missionVariables.feudal_tournament_offer == "EVENT_BRIEFING")
			{
				if(choice == "defer_event")
					{mission.runScreen({title: "Royal Hunting Lodge", messageKey: "feudal_tournament_deferred"})
					missionVariables.feudal_tournament_offer = "EVENT_DECLINED"
					}
				
				if(missionVariables.feudal_tournament == "EVENT1")			
				{	if(choice == "begin_event")
					{missionVariables.feudal_tournament = "EVENT1_RUNNING"
					missionVariables.feudal_tournament_offer = null
					missionVariables.feudal_tournament_kills = 0
					this.removeMissiles()
					player.ship.launch()
					}		
				}
				
				if(missionVariables.feudal_tournament == "EVENT2")			
				{	if(choice == "begin_event")
					{missionVariables.feudal_tournament = "EVENT2_RUNNING"
					missionVariables.feudal_tournament_offer = null
					missionVariables.feudal_tournament_kills = 0
					this.removeMissiles()
					if(player.ship.equipmentStatus("EQ_ENERGY_BOMB") == "EQUIPMENT_OK")
					{	player.ship.removeEquipment("EQ_ENERGY_BOMB")
						player.ship.awardEquipment("EQ_FS_BOMB_PLACEHOLDER")
						player.consoleMessage("Energy Bomb disabled")}
					player.ship.launch()
					}		
				}
				
				if(missionVariables.feudal_tournament == "EVENT3")			
				{	if(choice == "begin_event")
					{missionVariables.feudal_tournament = "EVENT3_RUNNING"
					missionVariables.feudal_tournament_offer = null
					missionVariables.feudal_tournament_scoops = 0
					player.ship.launch()
					}		
				}
				
				if(missionVariables.feudal_tournament == "EVENT4")			
				{	if(choice == "begin_event")
					{missionVariables.feudal_tournament = "EVENT4_RUNNING"
					missionVariables.feudal_tournament_offer = null
					missionVariables.feudal_tournament_scoops = 0
					player.ship.launch()
					}		
				}
				
				if(missionVariables.feudal_tournament == "EVENT5")			
				{	if(choice == "begin_event")
					{missionVariables.feudal_tournament = "EVENT5_RUNNING"
					missionVariables.feudal_tournament_offer = null
					missionVariables.feudal_tournament_ships = 100
					if(player.ship.equipmentStatus("EQ_ENERGY_BOMB") == "EQUIPMENT_OK")
					{	player.ship.removeEquipment("EQ_ENERGY_BOMB")
						player.ship.awardEquipment("EQ_FS_BOMB_PLACEHOLDER")
						player.consoleMessage("Energy Bomb disabled")}
					player.ship.launch()
					}		
				}
				
				if(missionVariables.feudal_tournament == "EVENT6")			
				{	if(choice == "begin_event")
					{missionVariables.feudal_tournament = "EVENT6_RUNNING"
					missionVariables.feudal_tournament_offer = null
					missionVariables.feudal_tournament_kills = 0
					if(player.ship.equipmentStatus("EQ_ENERGY_BOMB") == "EQUIPMENT_OK")
					{	player.ship.removeEquipment("EQ_ENERGY_BOMB")
						player.ship.awardEquipment("EQ_FS_BOMB_PLACEHOLDER")
						player.consoleMessage("Energy Bomb disabled")}
					this.removeMissiles()
					player.ship.launch()
					}		
				}	
			}	
	}				
// ship appearance on launching	
this.shipWillLaunchFromStation = function()

{	
	
	
	if(missionVariables.feudal_tournament_offer == "TOURNAMENT_OFFERED")
	missionVariables.feudal_tournament_offer = "TOURNAMENT_OPEN"
	
	
	
	if(missionVariables.feudal_tournament == "EVENT1_RUNNING")
		
		{system.legacy_addShipsWithinRadius("feudal-shield", 10, "wsm", [0, 122000, 0], 23000)}
	
	if(missionVariables.feudal_tournament == "EVENT2_RUNNING")
		{system.legacy_addShipsWithinRadius("feudal-drone-1", 1, "wsm", [0, 122000, 0], 5000)}
		
	if(missionVariables.feudal_tournament == "EVENT3_RUNNING")
		{
			if(player.ship.equipmentStatus("EQ_FUEL_INJECTION") == "EQUIPMENT_OK")
			{	player.ship.removeEquipment("EQ_FUEL_INJECTION")
				player.ship.awardEquipment("EQ_FS_INJECTION_PLACEHOLDER")
				player.consoleMessage("Fuel Injectors disabled")}
		system.legacy_addShipsWithinRadius("feudal-drone", 1, "wsm", [0, 122000, 0], 2000)
		system.addShips(expandDescription("[feudal_house_"+[galaxyNumber]+"]")+"-knight", 1, player.ship.position, 5000)
		system.addShips(expandDescription("[feudal_house_"+[galaxyNumber]+"]")+"-prince", 1, player.ship.position, 5000)
		system.addShips(expandDescription("[feudal_house_"+[galaxyNumber]+"]")+"-lord", 1, player.ship.position, 5000)
		}
	
	
	if(missionVariables.feudal_tournament == "EVENT4_RUNNING")
		{
		system.legacy_addShipsAtPrecisely("feudal-gate-away", 1, "wsu", [0, 0, -2.05])
		system.legacy_addShipsWithinRadius("feudal-gate-home", 1, "wsm", [0, 122000, 0], 20000)
		system.legacy_addShipsWithinRadius("new-asteroid", 64, "wsu", [0, 0, -2.01], 25000)
		system.legacy_addShipsWithinRadius("new-asteroid", 64, "wsu", [0, 0, -2.01], 12000)
		system.legacy_addShipsWithinRadius("new-asteroid", 32, "wsu", [0, 0, -2.01], 12000)
		system.legacy_addShipsWithinRadius("feudal-mine", 16, "wsu", [0, 0, -2.01], 12000)
		system.legacy_addShipsWithinRadius("feudal-mine", 16, "wsu", [0, 0, -2.01], 25000)
		system.legacy_addShipsWithinRadius("feudal-mine", 16, "wsu", [0, 0, -2.01], 25000)
		system.legacy_addShipsWithinRadius("new-asteroid", 32, "wsu", [0, 0, -2.01], 12000)
		system.legacy_addShipsWithinRadius("new-asteroid", 32, "wsu", [0, 0, -2.01], 12000)
		system.legacy_addShipsWithinRadius("feudal-shield-pod", 10, "wsu", [0, 0, -2.01], 12000)
		}
	
	if(missionVariables.feudal_tournament == "EVENT5_RUNNING")
	
	{	
		system.legacy_addShipsWithinRadius(expandDescription("[feudal_house_"+[galaxyNumber]+"]")+"-knight", 49, "wsm", [0, 122000, 0], 10000)
		system.legacy_addShipsWithinRadius(expandDescription("[feudal_house_"+[galaxyNumber]+"]")+"-lord", 30, "wsm", [0, 122000, 0], 10000)
		system.legacy_addShipsWithinRadius(expandDescription("[feudal_house_"+[galaxyNumber]+"]")+"-prince", 20, "wsm", [0, 122000, 0], 10000)
	}
	
	if(missionVariables.feudal_tournament == "EVENT6_RUNNING")
	
	{	
		system.legacy_addShipsWithinRadius([missionVariables.feudal_tournament_opponent_role], 1, "wsm", [0, 122000, 0], 5000)
	}
		
}
this.shipWillExitWitchspace = function()
{	
	
	if(missionVariables.feudal_tournament_jumpcount != null)
	++missionVariables.feudal_tournament_jumpcount
	
	if(missionVariables.feudal_tournament == "EVENT1_RUNNING" || missionVariables.feudal_tournament == "EVENT2_RUNNING" || missionVariables.feudal_tournament == "EVENT4_RUNNING" || missionVariables.feudal_tournament == "EVENT6_RUNNING")
	{this.resetTournament()
	player.commsMessage("Tournament event has been forfeit.")}

	if(missionVariables.feudal_tournament == "EVENT3_RUNNING")
	{this.resetTournament()
	player.commsMessage("Tournament event has been forfeit.")
	if(player.ship.equipmentStatus("EQ_FS_INJECTION_PLACEHOLDER") == "EQUIPMENT_OK")
		{
			player.ship.removeEquipment("EQ_FS_INJECTION_PLACEHOLDER")
			player.ship.awardEquipment("EQ_FUEL_INJECTION")
			player.consoleMessage("Fuel Injectors re-enabled")}			
		}
		
	if(missionVariables.feudal_tournament == "EVENT5_RUNNING" || missionVariables.feudal_tournament == "EVENT6_RUNNING")
	{this.resetTournament()
	player.commsMessage("Tournament event has been forfeit.")
	if(player.ship.equipmentStatus("EQ_FS_BOMB_PLACEHOLDER") == "EQUIPMENT_OK")
		{
			player.ship.removeEquipment("EQ_FS_BOMB_PLACEHOLDER")
			player.ship.awardEquipment("EQ_ENERGY_BOMB")
			player.consoleMessage("Energy Bomb re-enabled")}			
		}
	
}


this.playerEnteredNewGalaxy = function()
{	
	
	if(missionVariables.feudal_player_rank_no >= 1)
	this.resetTournament()
}

this.resetTournament = function()

{
	missionVariables.feudal_tournament = null
	missionVariables.feudal_tournament_offer = null
	mission.setInstructionsKey(null)
	missionVariables.feudal_tournament_kills = null
	missionVariables.feudal_tournament_home = null
	missionVariables.feudal_tournament_scoops = null
	missionVariables.feudal_tournament_ships = null
	missionVariables.feudal_tournament_opponent_role = null
	missionVariables.feudal_tournament_opponent_gender = null
	missionVariables.feudal_tournament_opponent_house = null		
	missionVariables.feudal_tournament_opponent_title = null
	missionVariables.feudal_tournament_opponent_firstname = null
	missionVariables.feudal_tournament_opponent_lastname = null
	missionVariables.feudal_tournament_opponent_of = null
	missionVariables.feudal_tournament_opponent_rank_no = null
	missionVariables.feudal_tournament_opponent_rank = null
	missionVariables.feudal_tournament_opponent_text = null
	missionVariables.feudal_tournament_jumpcount = 0
	missionVariables.feudal_tournament_deadline = null
}

this.defineTournamentGender = function() // pick a gender and select basic titles
{	missionVariables.feudal_tournament_opponent_gender = expandDescription("[feudal_gender]")
		
		if(missionVariables.feudal_tournament_opponent_gender == "he")
		{	
			if(missionVariables.feudal_tournament_opponent_rank_no == 1)
                        missionVariables.feudal_tournament_opponent_title = "Sir"
                        
			if(missionVariables.feudal_tournament_opponent_rank_no == 2)
                        missionVariables.feudal_tournament_opponent_title = "Lord"
		}									       
		
		if(missionVariables.feudal_tournament_opponent_gender == "she")	
			missionVariables.feudal_tournament_opponent_title = "Lady"			
}

this.defineTournamentOpponentHouse = function()
{missionVariables.feudal_tournament_opponent_house = expandDescription("[feudal_house_"+[galaxyNumber]+"]")
if(missionVariables.feudal_tournament_opponent_house == missionVariables.feudal_tournament_home)
this.defineTournamentOpponentHouse
}

this.defineTournamentInputs = function()
{	
	player.rankGenerator_house = missionVariables.feudal_tournament_opponent_house
	player.rankGenerator_gender = missionVariables.feudal_tournament_opponent_gender		
}

this.defineTournamentOutputs = function()
{	
	missionVariables.feudal_tournament_opponent_firstname = player.rankGenerator_feudal_firstname
	missionVariables.feudal_tournament_opponent_lastname = player.rankGenerator_feudal_lastname
	missionVariables.feudal_tournament_opponent_of = player.rankGenerator_of
	//log(missionVariables.feudal_tournament_opponent_rank_no)
	
	if(missionVariables.feudal_tournament_opponent_rank_no == 1)
	missionVariables.feudal_tournament_opponent_text = missionVariables.feudal_tournament_opponent_title+" "+missionVariables.feudal_tournament_opponent_firstname+" "+missionVariables.feudal_tournament_opponent_lastname+" of the House of "+missionVariables.feudal_tournament_opponent_house
	
	if(missionVariables.feudal_tournament_opponent_rank_no == 2)
	{missionVariables.feudal_tournament_opponent_rank = [player.rankGenerator_feudal_middle_rank]
	missionVariables.feudal_tournament_opponent_text = missionVariables.feudal_tournament_opponent_firstname+" "+missionVariables.feudal_tournament_opponent_lastname+", "+missionVariables.feudal_tournament_opponent_rank+" "+missionVariables.feudal_tournament_opponent_of+" "+missionVariables.feudal_tournament_opponent_house+","}
	
	if(missionVariables.feudal_tournament_opponent_rank_no == 3)
	   {missionVariables.feudal_tournament_opponent_rank = [player.rankGenerator_feudal_high_rank]
	missionVariables.feudal_tournament_opponent_text = missionVariables.feudal_tournament_opponent_firstname+" "+missionVariables.feudal_tournament_opponent_lastname+", "+missionVariables.feudal_tournament_opponent_rank+" "+missionVariables.feudal_tournament_opponent_of+" "+missionVariables.feudal_tournament_opponent_house+","}
}





